#define DIRECTDRAW_VERSION 0x0700

#include <ddraw.h>

// Gestion des erreurs
extern bool  DDFailedCheck(HRESULT hr, char *szMessage);
extern char *DDErrorString(HRESULT hr);

// Affichage d'un text dans une surface
extern HRESULT DDTextOut( LPDIRECTDRAWSURFACE7 lpDDSSurface, // Surface ou doit s'afficher le texte
                                char* lpString,  // Texte
                                COLORREF BackColor, // Couleur de fond
                                COLORREF TextColor, // Couleur du text
                                int posx, // position en x
                                int posy); // et en y

// Initialition de DirectDraw
extern bool DDInit( HWND hWnd );
extern bool g_bFullScreen; // Indique qu'on est en full screen ou en windows mode

// Dfinition cran , plein ecran ou windows ? si plein ecran, resolution de celui-ci
extern bool DDScreenMode( bool bFullScreen, int iResolX, int iResolY, int inumcolor);
// Cration de la surface, gnralement appel aprs DDscreenMode
extern bool DDCreatePBBuffer();
// Echange cran logique et cran physique
extern void DDFlipping();
// Fin de direct Draw
extern void DDDestroySurfaces(LPDIRECTDRAWSURFACE7 lpDDSurface);
// Dfinition de la zone de clipping
extern bool DDClipper();
// Convertion composante rouge vert bleu en un numro de couleur dans une palette (256 couleurs)
// ou en 1 octet dont la couleurs corresponds au 64K ou 16M
extern unsigned int CreateRGB( int r, int g, int b );
// Affichage d'un rectangle sur une surface
extern void DDRectangle( LPDIRECTDRAWSURFACE7 pDDS, int x, int y, int l_x, int l_y, int r, int g, int b );
// Contrle surfaces et leurs tampons,restoration des tampons si ncessaire
extern void CheckSurfaces(LPDIRECTDRAWSURFACE7 i_pDDS);
// Fill sur une surface entire
extern void DDFillSurface( LPDIRECTDRAWSURFACE7 lpDDSurface, int r, int g, int b );
// Creation d'une surface complmentaire
extern LPDIRECTDRAWSURFACE7 DDCreateOffScreenSurface(  int largeur, int hauteur,
								   LPDDPIXELFORMAT lpddpfFormat );
// Cration d'une surface  partir d'une image
extern IDirectDrawSurface7 * DDLoadBitmap(LPCSTR szBitmap, int dx, int dy, // DWORD dwFlags,
										 LPDDPIXELFORMAT lpddpfFormat
										 );
// Lecture de la couleur d'un point sur une surface
bool DDGetPixel (LPDIRECTDRAWSURFACE7 pdds, int x, int y);
// Copier une image bitmap vers une surface (utilis par DDLoadBitmap et DDInsertBitmap
extern HRESULT DDCopyBitmap(LPDIRECTDRAWSURFACE7 pdds, HBITMAP hbm, int x, int y, int dx, int dy);
// Insrer une image dans une surface existante
extern HRESULT DDInsertBitmap(IDirectDrawSurface7 *pdds, LPCSTR szBitmap); // Insere un bitmap dans une surface existante
extern bool CopySxyToSxy( int xsrc, int ysrc, int x1src, int y1src, DWORD xdest, DWORD ydest,
                LPDIRECTDRAWSURFACE7 lpDDSSource, // source surface
                LPDIRECTDRAWSURFACE7 lpDDSDest    // destination surface
                );

extern  LPDIRECTDRAW7        g_pDD      ; // Interface DDraw
extern	LPDIRECTDRAWSURFACE7 g_pDDS     ;  // Primary surface, cran physique
extern  LPDIRECTDRAWSURFACE7 g_pDDSBack ;  // Primary surface Back, cran logique

extern  unsigned char get_rouge;
extern  unsigned char get_vert;
extern  unsigned char get_bleu;

extern DWORD DDColorMatch(IDirectDrawSurface7 *pdds, COLORREF rgb);
extern HRESULT DDSetColorKey(IDirectDrawSurface7 *pdds, int r, int g, int b /*COLORREF rgb*/);

bool DDCtrlDD(HRESULT hr, char *cMessage);